$(header)
# Comment to re-premote because accurev sucks!

#Arguments to be passed to configure  
dlm_root = /opt/nc/dlms/smb
prefix = $(dlm_root)/data/samba
bindir = $(dlm_root)/apps
sbindir = $(dlm_root)/apps
libexecdir = $(dlm_root)/apps
libdir = ${dlm_root}/data/samba/lib

# The configure script uses krb5-config to get the initial list of Kerberos libraries
# for the KRB5_LIBS variable.
# The location of this program varies depending on your kernel version.
# fc12 /usr/kerberos/bin/krb5-config
# fc14 /usr/bin/krb5-config
#
# NOTE: In a cross compiling environment, this behavour of the configure script calling
# a program on the local system to get compilation information is incorrect. This information
# should be provided by the user to reflect what the target system has.
#
ifeq ($(wildcard "/usr/kerberos/bin/krb5-config"),)
	kerberosdir = "/usr/kerberos"
else ifeq ($(wildcard "/usr/bin/krb5-config"),)
	kerberosdir = "/usr"
else
	kerberosdir = "no"
endif

ifeq ($(TARGET_PROCESSOR),intel)
  EXTERNAL_MAKE_COMMAND := \
  $(BUILD_SCRIPTS_ROOT)/linkSrc.rb $(call get) $(call build-area); \
      $(BUILD_SCRIPTS_ROOT)/linkSrc.rb $(call build-area)/source3 $(call build-area)/$(TGTPLT); \
      cd $(call build-area)/$(TGTPLT); \
      chmod +x ./autogen.sh; \
      ./autogen.sh; \
      chmod +x ./configure; \
      ./configure  --enable-cups=no \
      --prefix=$(prefix) \
      --bindir=$(bindir) \
      --sbindir=$(sbindir) \
      --libdir=$(libdir) \
      --libexecdir=$(libexecdir) \
      --with-ads \
      --with-ldap \
      --with-krb5=$(kerberosdir) \
      --with-swatdir='$(dlm_root)/swat' \
      --with-libiconv='$(TOOLCHAIN_LIBDIR)/../export/dist/usr' \
      --with-build='i686-pc-linux-gnulibc2.3' \
      AR='$(ARCHIVER)' \
      X_LD='$(LD)' \
      CC='$(CC) -DBUILD_FOR_INTEL'; \
      make;
endif
ifeq ($(TARGET_PROCESSOR),ppc)
  EXTERNAL_MAKE_COMMAND := \
  $(BUILD_SCRIPTS_ROOT)/linkSrc.rb $(call get) $(call build-area); \
      $(BUILD_SCRIPTS_ROOT)/linkSrc.rb $(call build-area)/source3 $(call build-area)/$(TGTPLT); \
      cd $(call build-area)/$(TGTPLT); \
      chmod +x ./autogen.sh; \
      ./autogen.sh; \
      chmod +x ./configure; \
      CONFIG_SITE=../config.site.ppc ./configure \
      --enable-cups=no \
      --prefix=$(prefix) \
      --bindir=$(bindir) \
      --sbindir=$(sbindir) \
      --libdir=$(libdir) \
      --libexecdir=$(libexecdir) \
      --with-ads \
      --with-ldap \
      --with-krb5=$(kerberosdir) \
      --with-swatdir='$(dlm_root)/swat' \
      --with-libiconv='$(TOOLCHAIN_LIBDIR)/../export/dist/usr' \
      --build=i686-pc-linux-gnulibc2.3 \
      --host=powerpc-wrs-linux-gnu \
      --target=powerpc-wrs-linux-gnu \
      AR='$(ARCHIVER)' \
      X_LD='$(LD)' \
      CC='$(CC)'; \
      make;
endif
ifeq ($(TARGET_PROCESSOR),arm)
  EXTERNAL_MAKE_COMMAND := \
  $(BUILD_SCRIPTS_ROOT)/linkSrc.rb $(call get) $(call build-area); \
      $(BUILD_SCRIPTS_ROOT)/linkSrc.rb $(call build-area)/source3 $(call build-area)/$(TGTPLT); \
      cd $(call build-area)/$(TGTPLT); \
      chmod +x ./autogen.sh; \
      ./autogen.sh; \
      chmod +x ./configure; \
      CONFIG_SITE=../config.site.arm ./configure \
      --enable-cups=no \
      --prefix=$(prefix) \
      --bindir=$(bindir) \
      --sbindir=$(sbindir) \
      --libdir=$(libdir) \
      --libexecdir=$(libexecdir) \
      --with-ads \
      --with-ldap \
      --with-krb5=$(kerberosdir) \
      --with-swatdir='$(dlm_root)/swat' \
      --with-libiconv='$(TOOLCHAIN_LIBDIR)/../export/dist/usr' \
      --build=i686-pc-linux-gnulibc2.3 \
      --host=arm-wrs-linux-gnu \
      --target=arm-wrs-linux-gnu \
      AR='$(ARCHIVER)' \
      X_LD='$(LD)' \
      CC='$(CC)'; \
      make;
endif

PREREQUISITES := $(call library-dynamic,,cpi_stub)

EXTERNAL_CLEAN_COMMAND := \
      $(RM_F) -r $(call build-area);

samba_build_outputs := $(addprefix $(call build-area)/,\
  $(TGTPLT)/bin/smbclient \
  $(TGTPLT)/bin/smbd \
  $(TGTPLT)/bin/nmbd \
  $(TGTPLT)/bin/nmblookup \
  $(TGTPLT)/bin/net \
  $(TGTPLT)/bin/CP850.so \
  $(TGTPLT)/bin/CP437.so \
  codepages/lowcase.dat \
  codepages/upcase.dat \
  codepages/valid.dat \
  $(TGTPLT)/po/de.msg \
  $(TGTPLT)/po/en.msg \
  $(TGTPLT)/po/fr.msg \
  $(TGTPLT)/po/it.msg \
  $(TGTPLT)/po/ja.msg \
  $(TGTPLT)/po/nl.msg \
  $(TGTPLT)/po/pl.msg \
  $(TGTPLT)/po/tr.msg \
  $(TGTPLT)/bin/libtalloc.so.2 \
  $(TGTPLT)/bin/libtdb.so.1 \
  $(TGTPLT)/bin/libwbclient.so.0 \
)

$(call external-build,$(samba_build_outputs),$(EXTERNAL_MAKE_COMMAND),$(PREREQUISITES))
$(call external-clean,$(EXTERNAL_CLEAN_COMMAND))

deploy_location := $(BUILD_ROOT)/system/xad/nc/toolkits/bin/$(TGTPLT)/samba
samba_copy_done_target := $(call build-area)/__samba_copy_done

$(call generate,$(samba_build_outputs),$(samba_copy_done_target))

$(samba_copy_done_target): samba_build_outputs := $(samba_build_outputs)
$(samba_copy_done_target): deploy_location := $(deploy_location)

$(samba_copy_done_target): $(samba_build_outputs)
	$Q mkdir -p $(deploy_location)
	$Q for file in $(samba_build_outputs); do \
	       destination=$(deploy_location)/$$(basename $$file); \
	       cp -f $$file $$destination; \
	   done

$(footer)
